#!/bin/bash

# 
# Máster Universitario en Software Libre UOC
# Proyecto: WIFIPlant
# Licencia: MIT
# Autor: Pedro Cadavid
# Fecha: 04/10/2016
# Modificado original de https://github.com/DexterInd/GrovePi/blob/master/Software/Shell/Grove%20-%20LCD%20RGB%20Backlight/lcd.sh
#


# I2C addresses
backlight=0x62
character=0x3e

# backlight registers
mode1=0x00
mode2=0x01
pwm0=0x02
pwm1=0x03
pwm2=0x04
ledout=0x08

# character registers
display=0x80
letters=0x40


# backlight
# set to green

red=0x00
green=0xFF
blue=0x00

i2cset -y 1 $backlight $mode1 0x00   # mode 1 init, normal mode
i2cset -y 1 $backlight $mode2 0x00   # mode 2 init
#i2cset -y 1 $backlight $pwm0 $blue   # blue
#i2cset -y 1 $backlight $pwm1 $green  # green
#i2cset -y 1 $backlight $pwm2 $red    # red
i2cset -y 1 $backlight $ledout 0xAA  # led output state
sleep 1

# character
# Hello World

lcd_write_text()
{
   local length_string
    declare -a char

    if [ $# -eq 2 ]; then
        string_to_convert=$1
    fi

    length_string=${#string_to_convert}

    for i in `seq 0 1 $length_string`;
    do
        char[$i]=`echo ${string_to_convert:$i:1}`

        case "${char[$i]}" in

            0)  char[$i]="48"
                ;;
            1)  char[$i]="49"
                ;;
            2)  char[$i]="50"
                ;;
            3)  char[$i]="51"
                ;;
            4)  char[$i]="52"
                ;;
            5)  char[$i]="53"
                ;;
            6)  char[$i]="54"
                ;;
            7)  char[$i]="55"
                ;;
            8)  char[$i]="56"
                ;;
            9)  char[$i]="57"
                ;;
            a) char[$i]="97"
                ;;
            A) char[$i]="65"
                ;;
	    á) char[$i]="160"
                ;;
            Á) char[$i]="181"
                ;;
            b) char[$i]="98"
		;;
            B) char[$i]="66"
                ;;
            c) char[$i]="99"
		;;
            C) char[$i]="67"
                ;;
            d) char[$i]="100"
                ;;
	    D) char[$i]="68"
                ;;
            e) char[$i]="101"
		;;
            E) char[$i]="69"
		;;
            é) char[$i]="130"
		;;
            É) char[$i]="144"
                ;;
            f) char[$i]="102"
		;;
            F) char[$i]="70"
                ;;
            g) char[$i]="103"
		;;
            G) char[$i]="71"
                ;;
            h) char[$i]="104"
                ;;
            H) char[$i]="72"
                ;;
            i) char[$i]="105"
                ;;
            I) char[$i]="73"
                ;;
            í) char[$i]="161"
                ;;
            Í) char[$i]="214"
                ;;
            j) char[$i]="106"
                ;;
            J) char[$i]="74"
                ;;
            k) char[$i]="107"
                ;;
            K) char[$i]="75"
                ;;
            l) char[$i]="108"
                ;;
            L) char[$i]="76"
                ;;
            m) char[$i]="109"
                ;;
            M) char[$i]="77"
                ;;
            n) char[$i]="110"
                ;;
            N) char[$i]="78"
                ;;
            o) char[$i]="111"
                ;;
            O) char[$i]="79"
                ;;
            ó) char[$i]="162"
                ;;
            Ó) char[$i]="224"
                ;;
            p) char[$i]="112"
                ;;
            P) char[$i]="80"
                ;;
            q) char[$i]="113"
                ;;
            Q) char[$i]="81"
                ;;
            r) char[$i]="114"
                ;;
            R) char[$i]="82"
                ;;
            s) char[$i]="115"
                ;;
            S) char[$i]="83"
                ;;
            t) char[$i]="116"
                ;;
            T) char[$i]="84"
                ;;
            u) char[$i]="117"
                ;;
            U) char[$i]="85"
                ;;
            ú) char[$i]="163"
                ;;
            Ú) char[$i]="233"
                ;;
            v) char[$i]="118"
                ;;
            V) char[$i]="83"
                ;;
            w) char[$i]="119"
                ;;
            W) char[$i]="87"
                ;;
            x) char[$i]="120"
                ;;
            X) char[$i]="88"
                ;;
            y) char[$i]="121"
                ;;
            Y) char[$i]="89"
                ;;
            z) char[$i]="122"
               ;;
            Z) char[$i]="90"
                ;;
            '.') char[$i]="46"
                ;;
            ',') char[$i]="44"
                ;;
            '-') char[$i]="45"
                ;;
            '¿') char[$i]="168"
                ;;
            '?') char[$i]="63"
                ;;
            '@') char[$i]="64"
                ;;
            '/') char[$i]="47"
                ;;
            '\') char[$i]="92"
                ;;
            '') char[$i]="32"
                ;;
	    'º') char[$i]="167"
                ;;
            '%') char[$i]="37"
                ;;
            ':') char[$i]="58"
                ;;
        esac

        if [[ "$2" != "2" ]]; then
           i2cset -y 1 $character $display 0x01  # clear display
           i2cset -y 1 $character $display 0x0F  # display on, block cursor
           i2cset -y 1 $character $display 0x38  # 2 lines
        fi

        #Checks if we should write on line 1 or line 2
        if [[ "$2" == "2" ]]; then
           i2cset -y 1 $character $display 0x0F
           i2cset -y 1 $character $display 0xc0
        fi

        for i in `seq 0 1 $length_string`;
        do
	     i2cset -y 1 $character $letters ${char[$i]}
        done
    done
}

lcd_set_color()
{
    case "$1" in

    	'green')
		red=0x00
		green=0xFF
		blue=0x00
        ;;

        'yellow')
                red=0xFF
                green=0x78
                blue=0x00
        ;;

        'orange')
                red=0xFF
                green=0x3C
                blue=0x00
        ;;

        'light-red')
                red=0x96
                green=0x00
                blue=0x00
        ;;

	'red')
                red=0xFF
                green=0x00
                blue=0x00
        ;;

	'blue')
                red=0x00
                green=0x00
                blue=0xFF
        ;;


        'black')
                red=0x00
                green=0x00
                blue=0x00
                i2cset -y 1 $character $display 0x01
        ;;


    esac

    i2cset -y 1 $backlight $pwm0 $blue   # blue
    i2cset -y 1 $backlight $pwm1 $green  # green
    i2cset -y 1 $backlight $pwm2 $red    # red

}


#write_text "Temp:24C Hum:36% " "1"
#write_text "Lux:50% Soil:40%" "2"

function  lcd_blink()
{
 for i in `seq 1 1 $1`; do
 #rand=$(python -c "import random;print(random.uniform(0.1, 0.3))")
        set_color "black"
        sleep 0.3
        set_color "blue"
        sleep 0.1
 done
}

